class hadoopclu::hosts {

  # Get host entries from hiera
  $puppetheader = hiera('puppetheader', 'Managed by Puppet')
  
  $node_hosts_hsh = hiera('hosts::node_hosts_hsh', {})
  $site_hosts_hsh = hiera('hosts::site_hosts_hsh', {})
  
  file { "hosts_file" :
    ensure  => 'present',
    path    => hiera('hosts::hosts_path', '/etc/hosts'),
    content => template(hiera('hosts::hosts_tmpl', 'hadoopclu/hosts.erb')),
    owner   => 'root',
    group   => 'root',
    mode    => '0644',
  }

}
